"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// Determine if the function is an internal derive function based on properties
// define on the function.
function isDerivedFunction(fn) {
    return fn && fn.hasOwnProperty("__cooky-cutter-derive");
}
exports.isDerivedFunction = isDerivedFunction;
// Determine if the function is an internal factory function based on properties
// define on the function.
function isFactoryFunction(fn) {
    return fn && fn.hasOwnProperty("__cooky-cutter-factory");
}
exports.isFactoryFunction = isFactoryFunction;
// Determine if the function is an attribute function. Since this is end-user
// defined there is not a great way to know for sure if it exactly matches
// an attribute function, but this is a best guess. This should be used after
// all other function type checks.
function isAttributeFunction(fn) {
    return fn && {}.toString.call(fn) === "[object Function]";
}
exports.isAttributeFunction = isAttributeFunction;
